<img src="https://gcdn.thunderstore.io/live/repository/icons/Frogger-GroundReset-2.5.1.png.128x128_q95.png" align="right" alt="Project Logo" style="border-radius: 10px;">

# GroundReset

![Version Badge](https://img.shields.io/badge/version-2.5.1-green.svg)

A dedicated server mod that restores terrain back to its original state gradually over a configurable rate.

## About

GroundReset is a dedicated server mod that gradually resets the ground terrain across the map automatically.

No terrain changes occur for areas within:

- Wards from vanilla Valheim
- Wards from AzuMatt's WardIsLove mod
- Marketplaces from KGValheim's Marketplace and NPCs mod

## How It Works

Terrain across Valheim is generated by the game with a heightmap, composed of a very large set of point values. This mod
identifies changed terrain and calculates the amount of change done to the original heightmap value, known as the
current delta value. The current delta value is positive or negative depending on if the ground has been lowered or
raised from its initial height.

- This mod will divide the current delta value by the Divider value set in the configuration for each point to get the
  fraction amount to change the terrain by and towards the value of 0.
- Every amount of minutes defined in TheTriggerTime value in the configuration will have the mod modify the current
  delta value by the fraction amount calculated by the division of current delta value by the Divider.
- When the value of the point is close enough to 0 (as defined by ``Min Height To Stepped Reset``), the terrain fully
  resets to the original height assigned to by the game at the start of the world.
- Points located in the area of the active ward or the territory of a marketplace are not touched.

### Install Notes

Install only on dedicated servers. This mod should not be installed on clients. Players do not need to install this mod
on their side.

### Configuration

Configuration values can be changed while in-game using a Configuration Manager mod. Otherwise, please
open ``GroundReset.cfg`` created in the "BepInEx\config" folder to manually modify configurable values.

The two important values are:

- ``TheTriggerTime`` \[Float]: The interpolation rate. This is the amount of real-clock minutes before the mod
  progresses
  to another round of changes for all modified points on the map that are not protected or in a marketplace
  territory.<br>
- ``Divider`` \[Float]: The divider for the terrain restoration. Setting this higher will make changes more gradual and
  will require more time to get to the original terrain value.

For more detailed configuration, use the configs below:

- `Paint To Ignore` \[Boolean]: List of terrain paints that will be not reset. Valina paints are Dirt, Cultivated, Paved, Nothing. '(Cultivated) , (Paved)' means that Cultivated and Paved paints won't be reset. For paints from mods you can pass color in rbga format '(r, b, g, a)'
- `Reset Smoothing` \[Boolean]: Should the terrain smoothing be reset
- `Process Paint Lastly` \[Boolean]: Set to true so that the paint is reset only after the ground height delta and
  smoothing is completely reset. Otherwise, the paint will be reset at each reset step along with the height delta.
- `Process Smoothing After Height` \[Boolean]: Set to true so that the smoothing is reset only after the ground height
  delta is completely reset. Otherwise, the smoothing will be reset at each reset step along with the height delta.

Read the configuration file for other adjustable values.

### Compatibility

<a href="https://valheim.thunderstore.io/package/KGvalheim/Marketplace_And_Server_NPCs_Revamped/">
<img alt="Marketplace Logo" src="https://gcdn.thunderstore.io/live/repository/icons/KGvalheim-Marketplace_And_Server_NPCs_Revamped-9.2.2.png.128x128_q95.jpg" width="35"/> 
Marketplace And Server NPCs</a><br>
<a href="https://valheim.thunderstore.io/package/Azumatt/WardIsLove/">
<img alt="WardIsLove Logo" src="https://gcdn.thunderstore.io/live/repository/icons/Azumatt-WardIsLove-3.4.5.png.128x128_q95.png" width="35"/> 
WardIsLove</a><br>

### Contact

Discord - <img alt="GitHub Logo" src="https://freelogopng.com/images/all_img/1691730813discord-icon-png.png" width="16"/>
`justafrogger`<br>
Me on Thunderstore - <a href="https://valheim.thunderstore.io/package/Frogger/">
<img alt="Thunderstore Logo" src="https://gcdn.thunderstore.io/live/community/valheim/PNG_color_logo_only_1_transparent.png" width="14"/>
Frogger Mods</a><br>
GitHub - <a href="https://github.com/FroggerHH/GroundReset">
<img alt="GitHub Logo" src="https://github.githubassets.com/assets/pinned-octocat-093da3e6fa40.svg" width="16"/>
GroundReset</a><br>

This mod was commissioned by
<img alt="The VitByr avatar" src="https://cdn.discordapp.com/emojis/1103332829414301786.webp" width="18"/>
`VitByr`. If you need a custom mod, do not hesitate to reach me out 😉.<br>
Also, many thanks to
<img alt="The gdragon avatar" src="https://cdn.discordapp.com/emojis/1196058163401736325.webp?size=96&quality=lossless" width="18"/>
gdragon for the help with writing this text